#ifndef EXPRESSIONVISITOR_H
#define EXPRESSIONVISITOR_H

#include "Type.h"
#include "TypeError.h"

// Forward declaration of expression classes
class TrueExpression;
class FalseExpression;
class IntExpression;
class NegExpression;
class AddExpression;
class OrExpression;
class EqualsExpression;
class IfThenElseExpression;

template <typename T, typename E>
class ExpressionVisitor {
public:
    virtual ~ExpressionVisitor() {}

    virtual T visit(TrueExpression& e) = 0;
    virtual T visit(FalseExpression& e) = 0;
    virtual T visit(IntExpression& e) = 0;
    virtual T visit(NegExpression& e) = 0;
    virtual T visit(AddExpression& e) = 0;
    virtual T visit(OrExpression& e) = 0;
    virtual T visit(EqualsExpression& e) = 0;
    virtual T visit(IfThenElseExpression& e) = 0;
};

#endif // EXPRESSIONVISITOR_H
