#ifndef TYPECHECKER_H
#define TYPECHECKER_H

#include "Expression.h"
#include "ExpressionVisitor.h"

template <typename T, typename E>
class ExpressionVisitor; // Forward declaration

class TypeChecker : public ExpressionVisitor<Type, TypeError> {
public:
    Type visit(TrueExpression& e) override;
    Type visit(FalseExpression& e) override;
    Type visit(IntExpression& e) override;
    Type visit(NegExpression& e) override;
    Type visit(AddExpression& e) override;
    Type visit(OrExpression& e) override;
    Type visit(EqualsExpression& e) override;
    Type visit(IfThenElseExpression& e) override;

    static Type type_check(Expression& e);
};

#endif // TYPECHECKER_H

