#include "Expression.h"
#include "TypeChecker.h"
#include <gtest/gtest.h>

TEST(TypeCheckerTest, testVisitTrueExpression) {
    TrueExpression trueExpression;
    EXPECT_EQ(Type::BOOL, TypeChecker::type_check(trueExpression));
}

TEST(TypeCheckerTest, testVisitNegExpression) {
    TrueExpression trueExpression;
    NegExpression negExpression = new NegExpression(&trueExpression);
    EXPECT_THROW(TypeChecker::type_check(negExpression), TypeError);
}

// TODO We strongly advise you to write more tests...

int main(int argc, char** argv) {
    ::testing::InitGoogleTest(&argc, argv);
    return RUN_ALL_TESTS();
}
